<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `&#x2F;nix&#x2F;store&#x2F;v9jmyrpcwymx5d6inidy85x2ljzgm935-vendored-sources&#x2F;serde_json-1.0.78&#x2F;src&#x2F;macros.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>macros.rs - source</title><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../light.css"  id="themeStyle"><link rel="stylesheet" type="text/css" href="../../dark.css" disabled ><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled ><script id="default-settings" ></script><script src="../../storage.js"></script><script src="../../crates.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"><style type="text/css">#crate-search{background-image:url("../../down-arrow.svg");}</style></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="sidebar"><div class="sidebar-menu" role="button">&#9776;</div><a href='../../serde_json/index.html'><div class='logo-container rust-logo'><img src='../../rust-logo.png' alt='logo'></div></a></nav><div class="theme-picker"><button id="theme-picker" aria-label="Pick another theme!" aria-haspopup="menu" title="themes"><img width="18" height="18" alt="Pick another theme!" src="../../brush.svg"></button><div id="theme-choices" role="menu"></div></div><nav class="sub"><form class="search-form"><div class="search-container"><div><select id="crate-search"><option value="All crates">All crates</option></select><input class="search-input" name="search" disabled autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"></div><button type="button" id="help-button" title="help">?</button><a id="settings-menu" href="../../settings.html" title="settings"><img width="18" height="18" alt="Change settings" src="../../wheel.svg"></a></div></form></nav><section id="main" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">  1</span>
<span id="2">  2</span>
<span id="3">  3</span>
<span id="4">  4</span>
<span id="5">  5</span>
<span id="6">  6</span>
<span id="7">  7</span>
<span id="8">  8</span>
<span id="9">  9</span>
<span id="10"> 10</span>
<span id="11"> 11</span>
<span id="12"> 12</span>
<span id="13"> 13</span>
<span id="14"> 14</span>
<span id="15"> 15</span>
<span id="16"> 16</span>
<span id="17"> 17</span>
<span id="18"> 18</span>
<span id="19"> 19</span>
<span id="20"> 20</span>
<span id="21"> 21</span>
<span id="22"> 22</span>
<span id="23"> 23</span>
<span id="24"> 24</span>
<span id="25"> 25</span>
<span id="26"> 26</span>
<span id="27"> 27</span>
<span id="28"> 28</span>
<span id="29"> 29</span>
<span id="30"> 30</span>
<span id="31"> 31</span>
<span id="32"> 32</span>
<span id="33"> 33</span>
<span id="34"> 34</span>
<span id="35"> 35</span>
<span id="36"> 36</span>
<span id="37"> 37</span>
<span id="38"> 38</span>
<span id="39"> 39</span>
<span id="40"> 40</span>
<span id="41"> 41</span>
<span id="42"> 42</span>
<span id="43"> 43</span>
<span id="44"> 44</span>
<span id="45"> 45</span>
<span id="46"> 46</span>
<span id="47"> 47</span>
<span id="48"> 48</span>
<span id="49"> 49</span>
<span id="50"> 50</span>
<span id="51"> 51</span>
<span id="52"> 52</span>
<span id="53"> 53</span>
<span id="54"> 54</span>
<span id="55"> 55</span>
<span id="56"> 56</span>
<span id="57"> 57</span>
<span id="58"> 58</span>
<span id="59"> 59</span>
<span id="60"> 60</span>
<span id="61"> 61</span>
<span id="62"> 62</span>
<span id="63"> 63</span>
<span id="64"> 64</span>
<span id="65"> 65</span>
<span id="66"> 66</span>
<span id="67"> 67</span>
<span id="68"> 68</span>
<span id="69"> 69</span>
<span id="70"> 70</span>
<span id="71"> 71</span>
<span id="72"> 72</span>
<span id="73"> 73</span>
<span id="74"> 74</span>
<span id="75"> 75</span>
<span id="76"> 76</span>
<span id="77"> 77</span>
<span id="78"> 78</span>
<span id="79"> 79</span>
<span id="80"> 80</span>
<span id="81"> 81</span>
<span id="82"> 82</span>
<span id="83"> 83</span>
<span id="84"> 84</span>
<span id="85"> 85</span>
<span id="86"> 86</span>
<span id="87"> 87</span>
<span id="88"> 88</span>
<span id="89"> 89</span>
<span id="90"> 90</span>
<span id="91"> 91</span>
<span id="92"> 92</span>
<span id="93"> 93</span>
<span id="94"> 94</span>
<span id="95"> 95</span>
<span id="96"> 96</span>
<span id="97"> 97</span>
<span id="98"> 98</span>
<span id="99"> 99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
<span id="171">171</span>
<span id="172">172</span>
<span id="173">173</span>
<span id="174">174</span>
<span id="175">175</span>
<span id="176">176</span>
<span id="177">177</span>
<span id="178">178</span>
<span id="179">179</span>
<span id="180">180</span>
<span id="181">181</span>
<span id="182">182</span>
<span id="183">183</span>
<span id="184">184</span>
<span id="185">185</span>
<span id="186">186</span>
<span id="187">187</span>
<span id="188">188</span>
<span id="189">189</span>
<span id="190">190</span>
<span id="191">191</span>
<span id="192">192</span>
<span id="193">193</span>
<span id="194">194</span>
<span id="195">195</span>
<span id="196">196</span>
<span id="197">197</span>
<span id="198">198</span>
<span id="199">199</span>
<span id="200">200</span>
<span id="201">201</span>
<span id="202">202</span>
<span id="203">203</span>
<span id="204">204</span>
<span id="205">205</span>
<span id="206">206</span>
<span id="207">207</span>
<span id="208">208</span>
<span id="209">209</span>
<span id="210">210</span>
<span id="211">211</span>
<span id="212">212</span>
<span id="213">213</span>
<span id="214">214</span>
<span id="215">215</span>
<span id="216">216</span>
<span id="217">217</span>
<span id="218">218</span>
<span id="219">219</span>
<span id="220">220</span>
<span id="221">221</span>
<span id="222">222</span>
<span id="223">223</span>
<span id="224">224</span>
<span id="225">225</span>
<span id="226">226</span>
<span id="227">227</span>
<span id="228">228</span>
<span id="229">229</span>
<span id="230">230</span>
<span id="231">231</span>
<span id="232">232</span>
<span id="233">233</span>
<span id="234">234</span>
<span id="235">235</span>
<span id="236">236</span>
<span id="237">237</span>
<span id="238">238</span>
<span id="239">239</span>
<span id="240">240</span>
<span id="241">241</span>
<span id="242">242</span>
<span id="243">243</span>
<span id="244">244</span>
<span id="245">245</span>
<span id="246">246</span>
<span id="247">247</span>
<span id="248">248</span>
<span id="249">249</span>
<span id="250">250</span>
<span id="251">251</span>
<span id="252">252</span>
<span id="253">253</span>
<span id="254">254</span>
<span id="255">255</span>
<span id="256">256</span>
<span id="257">257</span>
<span id="258">258</span>
<span id="259">259</span>
<span id="260">260</span>
<span id="261">261</span>
<span id="262">262</span>
<span id="263">263</span>
<span id="264">264</span>
<span id="265">265</span>
<span id="266">266</span>
<span id="267">267</span>
<span id="268">268</span>
<span id="269">269</span>
<span id="270">270</span>
<span id="271">271</span>
<span id="272">272</span>
<span id="273">273</span>
<span id="274">274</span>
<span id="275">275</span>
<span id="276">276</span>
<span id="277">277</span>
<span id="278">278</span>
<span id="279">279</span>
<span id="280">280</span>
<span id="281">281</span>
<span id="282">282</span>
<span id="283">283</span>
<span id="284">284</span>
<span id="285">285</span>
<span id="286">286</span>
<span id="287">287</span>
<span id="288">288</span>
<span id="289">289</span>
<span id="290">290</span>
<span id="291">291</span>
<span id="292">292</span>
<span id="293">293</span>
<span id="294">294</span>
<span id="295">295</span>
<span id="296">296</span>
<span id="297">297</span>
<span id="298">298</span>
<span id="299">299</span>
<span id="300">300</span>
<span id="301">301</span>
<span id="302">302</span>
<span id="303">303</span>
</pre><pre class="rust"><code><span class="doccomment">/// Construct a `serde_json::Value` from a JSON literal.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">/// # use serde_json::json;</span>
<span class="doccomment">/// #</span>
<span class="doccomment">/// let value = json!({</span>
<span class="doccomment">///     &quot;code&quot;: 200,</span>
<span class="doccomment">///     &quot;success&quot;: true,</span>
<span class="doccomment">///     &quot;payload&quot;: {</span>
<span class="doccomment">///         &quot;features&quot;: [</span>
<span class="doccomment">///             &quot;serde&quot;,</span>
<span class="doccomment">///             &quot;json&quot;</span>
<span class="doccomment">///         ]</span>
<span class="doccomment">///     }</span>
<span class="doccomment">/// });</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Variables or expressions can be interpolated into the JSON literal. Any type</span>
<span class="doccomment">/// interpolated into an array element or object value must implement Serde&#39;s</span>
<span class="doccomment">/// `Serialize` trait, while any type interpolated into a object key must</span>
<span class="doccomment">/// implement `Into&lt;String&gt;`. If the `Serialize` implementation of the</span>
<span class="doccomment">/// interpolated type decides to fail, or if the interpolated type contains a</span>
<span class="doccomment">/// map with non-string keys, the `json!` macro will panic.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">/// # use serde_json::json;</span>
<span class="doccomment">/// #</span>
<span class="doccomment">/// let code = 200;</span>
<span class="doccomment">/// let features = vec![&quot;serde&quot;, &quot;json&quot;];</span>
<span class="doccomment">///</span>
<span class="doccomment">/// let value = json!({</span>
<span class="doccomment">///     &quot;code&quot;: code,</span>
<span class="doccomment">///     &quot;success&quot;: code == 200,</span>
<span class="doccomment">///     &quot;payload&quot;: {</span>
<span class="doccomment">///         features[0]: features[1]</span>
<span class="doccomment">///     }</span>
<span class="doccomment">/// });</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Trailing commas are allowed inside both arrays and objects.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">/// # use serde_json::json;</span>
<span class="doccomment">/// #</span>
<span class="doccomment">/// let value = json!([</span>
<span class="doccomment">///     &quot;notice&quot;,</span>
<span class="doccomment">///     &quot;the&quot;,</span>
<span class="doccomment">///     &quot;trailing&quot;,</span>
<span class="doccomment">///     &quot;comma --&gt;&quot;,</span>
<span class="doccomment">/// ]);</span>
<span class="doccomment">/// ```</span>
<span class="attribute">#[<span class="ident">macro_export</span>(<span class="ident">local_inner_macros</span>)]</span>
<span class="macro">macro_rules!</span> <span class="ident">json</span> {
    <span class="comment">// Hide distracting implementation details from the generated rustdoc.</span>
    ($(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">json</span>:<span class="ident">tt</span>)<span class="op">+</span>) <span class="op">=</span><span class="op">&gt;</span> {
        <span class="macro">json_internal!</span>($(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">json</span>)<span class="op">+</span>)
    };
}

<span class="comment">// Rocket relies on this because they export their own `json!` with a different</span>
<span class="comment">// doc comment than ours, and various Rust bugs prevent them from calling our</span>
<span class="comment">// `json!` from their `json!` so they call `json_internal!` directly. Check with</span>
<span class="comment">// @SergioBenitez before making breaking changes to this macro.</span>
<span class="comment">//</span>
<span class="comment">// Changes are fine as long as `json_internal!` does not call any new helper</span>
<span class="comment">// macros and can still be invoked as `json_internal!($($json)+)`.</span>
<span class="attribute">#[<span class="ident">macro_export</span>(<span class="ident">local_inner_macros</span>)]</span>
<span class="attribute">#[<span class="ident">doc</span>(<span class="ident">hidden</span>)]</span>
<span class="macro">macro_rules!</span> <span class="ident">json_internal</span> {
    <span class="comment">//////////////////////////////////////////////////////////////////////////</span>
    <span class="comment">// TT muncher for parsing the inside of an array [...]. Produces a vec![...]</span>
    <span class="comment">// of the elements.</span>
    <span class="comment">//</span>
    <span class="comment">// Must be invoked as: json_internal!(@array [] $($tt)*)</span>
    <span class="comment">//////////////////////////////////////////////////////////////////////////</span>

    <span class="comment">// Done with trailing comma.</span>
    (@<span class="ident">array</span> [$(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">elems</span>:<span class="ident">expr</span>,)<span class="kw-2">*</span>]) <span class="op">=</span><span class="op">&gt;</span> {
        <span class="macro">json_internal_vec!</span>[$(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">elems</span>,)<span class="kw-2">*</span>]
    };

    <span class="comment">// Done without trailing comma.</span>
    (@<span class="ident">array</span> [$(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">elems</span>:<span class="ident">expr</span>),<span class="kw-2">*</span>]) <span class="op">=</span><span class="op">&gt;</span> {
        <span class="macro">json_internal_vec!</span>[$(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">elems</span>),<span class="kw-2">*</span>]
    };

    <span class="comment">// Next element is `null`.</span>
    (@<span class="ident">array</span> [$(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">elems</span>:<span class="ident">expr</span>,)<span class="kw-2">*</span>] <span class="ident">null</span> $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">rest</span>:<span class="ident">tt</span>)<span class="kw-2">*</span>) <span class="op">=</span><span class="op">&gt;</span> {
        <span class="macro">json_internal!</span>(@<span class="ident">array</span> [$(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">elems</span>,)<span class="op">*</span> <span class="macro">json_internal!</span>(<span class="ident">null</span>)] $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">rest</span>)<span class="kw-2">*</span>)
    };

    <span class="comment">// Next element is `true`.</span>
    (@<span class="ident">array</span> [$(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">elems</span>:<span class="ident">expr</span>,)<span class="kw-2">*</span>] <span class="bool-val">true</span> $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">rest</span>:<span class="ident">tt</span>)<span class="kw-2">*</span>) <span class="op">=</span><span class="op">&gt;</span> {
        <span class="macro">json_internal!</span>(@<span class="ident">array</span> [$(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">elems</span>,)<span class="op">*</span> <span class="macro">json_internal!</span>(<span class="bool-val">true</span>)] $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">rest</span>)<span class="kw-2">*</span>)
    };

    <span class="comment">// Next element is `false`.</span>
    (@<span class="ident">array</span> [$(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">elems</span>:<span class="ident">expr</span>,)<span class="kw-2">*</span>] <span class="bool-val">false</span> $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">rest</span>:<span class="ident">tt</span>)<span class="kw-2">*</span>) <span class="op">=</span><span class="op">&gt;</span> {
        <span class="macro">json_internal!</span>(@<span class="ident">array</span> [$(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">elems</span>,)<span class="op">*</span> <span class="macro">json_internal!</span>(<span class="bool-val">false</span>)] $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">rest</span>)<span class="kw-2">*</span>)
    };

    <span class="comment">// Next element is an array.</span>
    (@<span class="ident">array</span> [$(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">elems</span>:<span class="ident">expr</span>,)<span class="kw-2">*</span>] [$(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">array</span>:<span class="ident">tt</span>)<span class="kw-2">*</span>] $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">rest</span>:<span class="ident">tt</span>)<span class="kw-2">*</span>) <span class="op">=</span><span class="op">&gt;</span> {
        <span class="macro">json_internal!</span>(@<span class="ident">array</span> [$(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">elems</span>,)<span class="op">*</span> <span class="macro">json_internal!</span>([$(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">array</span>)<span class="kw-2">*</span>])] $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">rest</span>)<span class="kw-2">*</span>)
    };

    <span class="comment">// Next element is a map.</span>
    (@<span class="ident">array</span> [$(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">elems</span>:<span class="ident">expr</span>,)<span class="kw-2">*</span>] {$(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">map</span>:<span class="ident">tt</span>)<span class="kw-2">*</span>} $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">rest</span>:<span class="ident">tt</span>)<span class="kw-2">*</span>) <span class="op">=</span><span class="op">&gt;</span> {
        <span class="macro">json_internal!</span>(@<span class="ident">array</span> [$(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">elems</span>,)<span class="op">*</span> <span class="macro">json_internal!</span>({$(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">map</span>)<span class="kw-2">*</span>})] $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">rest</span>)<span class="kw-2">*</span>)
    };

    <span class="comment">// Next element is an expression followed by comma.</span>
    (@<span class="ident">array</span> [$(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">elems</span>:<span class="ident">expr</span>,)<span class="kw-2">*</span>] <span class="macro-nonterminal">$</span><span class="macro-nonterminal">next</span>:<span class="ident">expr</span>, $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">rest</span>:<span class="ident">tt</span>)<span class="kw-2">*</span>) <span class="op">=</span><span class="op">&gt;</span> {
        <span class="macro">json_internal!</span>(@<span class="ident">array</span> [$(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">elems</span>,)<span class="op">*</span> <span class="macro">json_internal!</span>(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">next</span>),] $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">rest</span>)<span class="kw-2">*</span>)
    };

    <span class="comment">// Last element is an expression with no trailing comma.</span>
    (@<span class="ident">array</span> [$(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">elems</span>:<span class="ident">expr</span>,)<span class="kw-2">*</span>] <span class="macro-nonterminal">$</span><span class="macro-nonterminal">last</span>:<span class="ident">expr</span>) <span class="op">=</span><span class="op">&gt;</span> {
        <span class="macro">json_internal!</span>(@<span class="ident">array</span> [$(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">elems</span>,)<span class="op">*</span> <span class="macro">json_internal!</span>(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">last</span>)])
    };

    <span class="comment">// Comma after the most recent element.</span>
    (@<span class="ident">array</span> [$(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">elems</span>:<span class="ident">expr</span>),<span class="kw-2">*</span>] , $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">rest</span>:<span class="ident">tt</span>)<span class="kw-2">*</span>) <span class="op">=</span><span class="op">&gt;</span> {
        <span class="macro">json_internal!</span>(@<span class="ident">array</span> [$(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">elems</span>,)<span class="kw-2">*</span>] $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">rest</span>)<span class="kw-2">*</span>)
    };

    <span class="comment">// Unexpected token after most recent element.</span>
    (@<span class="ident">array</span> [$(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">elems</span>:<span class="ident">expr</span>),<span class="kw-2">*</span>] <span class="macro-nonterminal">$</span><span class="macro-nonterminal">unexpected</span>:<span class="ident">tt</span> $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">rest</span>:<span class="ident">tt</span>)<span class="kw-2">*</span>) <span class="op">=</span><span class="op">&gt;</span> {
        <span class="macro">json_unexpected!</span>(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">unexpected</span>)
    };

    <span class="comment">//////////////////////////////////////////////////////////////////////////</span>
    <span class="comment">// TT muncher for parsing the inside of an object {...}. Each entry is</span>
    <span class="comment">// inserted into the given map variable.</span>
    <span class="comment">//</span>
    <span class="comment">// Must be invoked as: json_internal!(@object $map () ($($tt)*) ($($tt)*))</span>
    <span class="comment">//</span>
    <span class="comment">// We require two copies of the input tokens so that we can match on one</span>
    <span class="comment">// copy and trigger errors on the other copy.</span>
    <span class="comment">//////////////////////////////////////////////////////////////////////////</span>

    <span class="comment">// Done.</span>
    (@<span class="ident">object</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">object</span>:<span class="ident">ident</span> () () ()) <span class="op">=</span><span class="op">&gt;</span> {};

    <span class="comment">// Insert the current entry followed by trailing comma.</span>
    (@<span class="ident">object</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">object</span>:<span class="ident">ident</span> [$(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">key</span>:<span class="ident">tt</span>)<span class="op">+</span>] (<span class="macro-nonterminal">$</span><span class="macro-nonterminal">value</span>:<span class="ident">expr</span>) , $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">rest</span>:<span class="ident">tt</span>)<span class="kw-2">*</span>) <span class="op">=</span><span class="op">&gt;</span> {
        <span class="kw">let</span> <span class="kw">_</span> <span class="op">=</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">object</span>.<span class="ident">insert</span>(($(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">key</span>)<span class="op">+</span>).<span class="ident">into</span>(), <span class="macro-nonterminal">$</span><span class="macro-nonterminal">value</span>);
        <span class="macro">json_internal!</span>(@<span class="ident">object</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">object</span> () ($(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">rest</span>)<span class="kw-2">*</span>) ($(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">rest</span>)<span class="kw-2">*</span>));
    };

    <span class="comment">// Current entry followed by unexpected token.</span>
    (@<span class="ident">object</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">object</span>:<span class="ident">ident</span> [$(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">key</span>:<span class="ident">tt</span>)<span class="op">+</span>] (<span class="macro-nonterminal">$</span><span class="macro-nonterminal">value</span>:<span class="ident">expr</span>) <span class="macro-nonterminal">$</span><span class="macro-nonterminal">unexpected</span>:<span class="ident">tt</span> $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">rest</span>:<span class="ident">tt</span>)<span class="kw-2">*</span>) <span class="op">=</span><span class="op">&gt;</span> {
        <span class="macro">json_unexpected!</span>(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">unexpected</span>);
    };

    <span class="comment">// Insert the last entry without trailing comma.</span>
    (@<span class="ident">object</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">object</span>:<span class="ident">ident</span> [$(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">key</span>:<span class="ident">tt</span>)<span class="op">+</span>] (<span class="macro-nonterminal">$</span><span class="macro-nonterminal">value</span>:<span class="ident">expr</span>)) <span class="op">=</span><span class="op">&gt;</span> {
        <span class="kw">let</span> <span class="kw">_</span> <span class="op">=</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">object</span>.<span class="ident">insert</span>(($(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">key</span>)<span class="op">+</span>).<span class="ident">into</span>(), <span class="macro-nonterminal">$</span><span class="macro-nonterminal">value</span>);
    };

    <span class="comment">// Next value is `null`.</span>
    (@<span class="ident">object</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">object</span>:<span class="ident">ident</span> ($(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">key</span>:<span class="ident">tt</span>)<span class="op">+</span>) (: <span class="ident">null</span> $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">rest</span>:<span class="ident">tt</span>)<span class="kw-2">*</span>) <span class="macro-nonterminal">$</span><span class="macro-nonterminal">copy</span>:<span class="ident">tt</span>) <span class="op">=</span><span class="op">&gt;</span> {
        <span class="macro">json_internal!</span>(@<span class="ident">object</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">object</span> [$(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">key</span>)<span class="op">+</span>] (<span class="macro">json_internal!</span>(<span class="ident">null</span>)) $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">rest</span>)<span class="kw-2">*</span>);
    };

    <span class="comment">// Next value is `true`.</span>
    (@<span class="ident">object</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">object</span>:<span class="ident">ident</span> ($(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">key</span>:<span class="ident">tt</span>)<span class="op">+</span>) (: <span class="bool-val">true</span> $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">rest</span>:<span class="ident">tt</span>)<span class="kw-2">*</span>) <span class="macro-nonterminal">$</span><span class="macro-nonterminal">copy</span>:<span class="ident">tt</span>) <span class="op">=</span><span class="op">&gt;</span> {
        <span class="macro">json_internal!</span>(@<span class="ident">object</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">object</span> [$(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">key</span>)<span class="op">+</span>] (<span class="macro">json_internal!</span>(<span class="bool-val">true</span>)) $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">rest</span>)<span class="kw-2">*</span>);
    };

    <span class="comment">// Next value is `false`.</span>
    (@<span class="ident">object</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">object</span>:<span class="ident">ident</span> ($(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">key</span>:<span class="ident">tt</span>)<span class="op">+</span>) (: <span class="bool-val">false</span> $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">rest</span>:<span class="ident">tt</span>)<span class="kw-2">*</span>) <span class="macro-nonterminal">$</span><span class="macro-nonterminal">copy</span>:<span class="ident">tt</span>) <span class="op">=</span><span class="op">&gt;</span> {
        <span class="macro">json_internal!</span>(@<span class="ident">object</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">object</span> [$(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">key</span>)<span class="op">+</span>] (<span class="macro">json_internal!</span>(<span class="bool-val">false</span>)) $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">rest</span>)<span class="kw-2">*</span>);
    };

    <span class="comment">// Next value is an array.</span>
    (@<span class="ident">object</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">object</span>:<span class="ident">ident</span> ($(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">key</span>:<span class="ident">tt</span>)<span class="op">+</span>) (: [$(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">array</span>:<span class="ident">tt</span>)<span class="kw-2">*</span>] $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">rest</span>:<span class="ident">tt</span>)<span class="kw-2">*</span>) <span class="macro-nonterminal">$</span><span class="macro-nonterminal">copy</span>:<span class="ident">tt</span>) <span class="op">=</span><span class="op">&gt;</span> {
        <span class="macro">json_internal!</span>(@<span class="ident">object</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">object</span> [$(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">key</span>)<span class="op">+</span>] (<span class="macro">json_internal!</span>([$(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">array</span>)<span class="kw-2">*</span>])) $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">rest</span>)<span class="kw-2">*</span>);
    };

    <span class="comment">// Next value is a map.</span>
    (@<span class="ident">object</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">object</span>:<span class="ident">ident</span> ($(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">key</span>:<span class="ident">tt</span>)<span class="op">+</span>) (: {$(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">map</span>:<span class="ident">tt</span>)<span class="kw-2">*</span>} $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">rest</span>:<span class="ident">tt</span>)<span class="kw-2">*</span>) <span class="macro-nonterminal">$</span><span class="macro-nonterminal">copy</span>:<span class="ident">tt</span>) <span class="op">=</span><span class="op">&gt;</span> {
        <span class="macro">json_internal!</span>(@<span class="ident">object</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">object</span> [$(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">key</span>)<span class="op">+</span>] (<span class="macro">json_internal!</span>({$(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">map</span>)<span class="kw-2">*</span>})) $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">rest</span>)<span class="kw-2">*</span>);
    };

    <span class="comment">// Next value is an expression followed by comma.</span>
    (@<span class="ident">object</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">object</span>:<span class="ident">ident</span> ($(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">key</span>:<span class="ident">tt</span>)<span class="op">+</span>) (: <span class="macro-nonterminal">$</span><span class="macro-nonterminal">value</span>:<span class="ident">expr</span> , $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">rest</span>:<span class="ident">tt</span>)<span class="kw-2">*</span>) <span class="macro-nonterminal">$</span><span class="macro-nonterminal">copy</span>:<span class="ident">tt</span>) <span class="op">=</span><span class="op">&gt;</span> {
        <span class="macro">json_internal!</span>(@<span class="ident">object</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">object</span> [$(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">key</span>)<span class="op">+</span>] (<span class="macro">json_internal!</span>(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">value</span>)) , $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">rest</span>)<span class="kw-2">*</span>);
    };

    <span class="comment">// Last value is an expression with no trailing comma.</span>
    (@<span class="ident">object</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">object</span>:<span class="ident">ident</span> ($(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">key</span>:<span class="ident">tt</span>)<span class="op">+</span>) (: <span class="macro-nonterminal">$</span><span class="macro-nonterminal">value</span>:<span class="ident">expr</span>) <span class="macro-nonterminal">$</span><span class="macro-nonterminal">copy</span>:<span class="ident">tt</span>) <span class="op">=</span><span class="op">&gt;</span> {
        <span class="macro">json_internal!</span>(@<span class="ident">object</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">object</span> [$(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">key</span>)<span class="op">+</span>] (<span class="macro">json_internal!</span>(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">value</span>)));
    };

    <span class="comment">// Missing value for last entry. Trigger a reasonable error message.</span>
    (@<span class="ident">object</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">object</span>:<span class="ident">ident</span> ($(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">key</span>:<span class="ident">tt</span>)<span class="op">+</span>) (:) <span class="macro-nonterminal">$</span><span class="macro-nonterminal">copy</span>:<span class="ident">tt</span>) <span class="op">=</span><span class="op">&gt;</span> {
        <span class="comment">// &quot;unexpected end of macro invocation&quot;</span>
        <span class="macro">json_internal!</span>();
    };

    <span class="comment">// Missing colon and value for last entry. Trigger a reasonable error</span>
    <span class="comment">// message.</span>
    (@<span class="ident">object</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">object</span>:<span class="ident">ident</span> ($(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">key</span>:<span class="ident">tt</span>)<span class="op">+</span>) () <span class="macro-nonterminal">$</span><span class="macro-nonterminal">copy</span>:<span class="ident">tt</span>) <span class="op">=</span><span class="op">&gt;</span> {
        <span class="comment">// &quot;unexpected end of macro invocation&quot;</span>
        <span class="macro">json_internal!</span>();
    };

    <span class="comment">// Misplaced colon. Trigger a reasonable error message.</span>
    (@<span class="ident">object</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">object</span>:<span class="ident">ident</span> () (: $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">rest</span>:<span class="ident">tt</span>)<span class="kw-2">*</span>) (<span class="macro-nonterminal">$</span><span class="macro-nonterminal">colon</span>:<span class="ident">tt</span> $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">copy</span>:<span class="ident">tt</span>)<span class="kw-2">*</span>)) <span class="op">=</span><span class="op">&gt;</span> {
        <span class="comment">// Takes no arguments so &quot;no rules expected the token `:`&quot;.</span>
        <span class="macro">json_unexpected!</span>(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">colon</span>);
    };

    <span class="comment">// Found a comma inside a key. Trigger a reasonable error message.</span>
    (@<span class="ident">object</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">object</span>:<span class="ident">ident</span> ($(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">key</span>:<span class="ident">tt</span>)<span class="kw-2">*</span>) (, $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">rest</span>:<span class="ident">tt</span>)<span class="kw-2">*</span>) (<span class="macro-nonterminal">$</span><span class="macro-nonterminal">comma</span>:<span class="ident">tt</span> $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">copy</span>:<span class="ident">tt</span>)<span class="kw-2">*</span>)) <span class="op">=</span><span class="op">&gt;</span> {
        <span class="comment">// Takes no arguments so &quot;no rules expected the token `,`&quot;.</span>
        <span class="macro">json_unexpected!</span>(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">comma</span>);
    };

    <span class="comment">// Key is fully parenthesized. This avoids clippy double_parens false</span>
    <span class="comment">// positives because the parenthesization may be necessary here.</span>
    (@<span class="ident">object</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">object</span>:<span class="ident">ident</span> () ((<span class="macro-nonterminal">$</span><span class="macro-nonterminal">key</span>:<span class="ident">expr</span>) : $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">rest</span>:<span class="ident">tt</span>)<span class="kw-2">*</span>) <span class="macro-nonterminal">$</span><span class="macro-nonterminal">copy</span>:<span class="ident">tt</span>) <span class="op">=</span><span class="op">&gt;</span> {
        <span class="macro">json_internal!</span>(@<span class="ident">object</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">object</span> (<span class="macro-nonterminal">$</span><span class="macro-nonterminal">key</span>) (: $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">rest</span>)<span class="kw-2">*</span>) (: $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">rest</span>)<span class="kw-2">*</span>));
    };

    <span class="comment">// Refuse to absorb colon token into key expression.</span>
    (@<span class="ident">object</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">object</span>:<span class="ident">ident</span> ($(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">key</span>:<span class="ident">tt</span>)<span class="kw-2">*</span>) (: $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">unexpected</span>:<span class="ident">tt</span>)<span class="op">+</span>) <span class="macro-nonterminal">$</span><span class="macro-nonterminal">copy</span>:<span class="ident">tt</span>) <span class="op">=</span><span class="op">&gt;</span> {
        <span class="macro">json_expect_expr_comma!</span>($(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">unexpected</span>)<span class="op">+</span>);
    };

    <span class="comment">// Munch a token into the current key.</span>
    (@<span class="ident">object</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">object</span>:<span class="ident">ident</span> ($(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">key</span>:<span class="ident">tt</span>)<span class="kw-2">*</span>) (<span class="macro-nonterminal">$</span><span class="macro-nonterminal">tt</span>:<span class="ident">tt</span> $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">rest</span>:<span class="ident">tt</span>)<span class="kw-2">*</span>) <span class="macro-nonterminal">$</span><span class="macro-nonterminal">copy</span>:<span class="ident">tt</span>) <span class="op">=</span><span class="op">&gt;</span> {
        <span class="macro">json_internal!</span>(@<span class="ident">object</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">object</span> ($(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">key</span>)<span class="op">*</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">tt</span>) ($(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">rest</span>)<span class="kw-2">*</span>) ($(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">rest</span>)<span class="kw-2">*</span>));
    };

    <span class="comment">//////////////////////////////////////////////////////////////////////////</span>
    <span class="comment">// The main implementation.</span>
    <span class="comment">//</span>
    <span class="comment">// Must be invoked as: json_internal!($($json)+)</span>
    <span class="comment">//////////////////////////////////////////////////////////////////////////</span>

    (<span class="ident">null</span>) <span class="op">=</span><span class="op">&gt;</span> {
        <span class="macro-nonterminal">$</span><span class="macro-nonterminal">crate::Value::Null</span>
    };

    (<span class="bool-val">true</span>) <span class="op">=</span><span class="op">&gt;</span> {
        <span class="macro-nonterminal">$</span><span class="macro-nonterminal">crate::Value::Bool</span>(<span class="bool-val">true</span>)
    };

    (<span class="bool-val">false</span>) <span class="op">=</span><span class="op">&gt;</span> {
        <span class="macro-nonterminal">$</span><span class="macro-nonterminal">crate::Value::Bool</span>(<span class="bool-val">false</span>)
    };

    ([]) <span class="op">=</span><span class="op">&gt;</span> {
        <span class="macro-nonterminal">$</span><span class="macro-nonterminal">crate::Value::Array</span>(<span class="macro">json_internal_vec!</span>[])
    };

    ([ $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">tt</span>:<span class="ident">tt</span>)<span class="op">+</span> ]) <span class="op">=</span><span class="op">&gt;</span> {
        <span class="macro-nonterminal">$</span><span class="macro-nonterminal">crate::Value::Array</span>(<span class="macro">json_internal!</span>(@<span class="ident">array</span> [] $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">tt</span>)<span class="op">+</span>))
    };

    ({}) <span class="op">=</span><span class="op">&gt;</span> {
        <span class="macro-nonterminal">$</span><span class="macro-nonterminal">crate::Value::Object</span>(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">crate::Map::new</span>())
    };

    ({ $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">tt</span>:<span class="ident">tt</span>)<span class="op">+</span> }) <span class="op">=</span><span class="op">&gt;</span> {
        <span class="macro-nonterminal">$</span><span class="macro-nonterminal">crate::Value::Object</span>({
            <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">object</span> <span class="op">=</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">crate::Map::new</span>();
            <span class="macro">json_internal!</span>(@<span class="ident">object</span> <span class="ident">object</span> () ($(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">tt</span>)<span class="op">+</span>) ($(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">tt</span>)<span class="op">+</span>));
            <span class="ident">object</span>
        })
    };

    <span class="comment">// Any Serialize type: numbers, strings, struct literals, variables etc.</span>
    <span class="comment">// Must be below every other rule.</span>
    (<span class="macro-nonterminal">$</span><span class="macro-nonterminal">other</span>:<span class="ident">expr</span>) <span class="op">=</span><span class="op">&gt;</span> {
        <span class="macro-nonterminal">$</span><span class="macro-nonterminal">crate::to_value</span>(<span class="kw-2">&amp;</span><span class="macro-nonterminal">$</span><span class="macro-nonterminal">other</span>).<span class="ident">unwrap</span>()
    };
}

<span class="comment">// The json_internal macro above cannot invoke vec directly because it uses</span>
<span class="comment">// local_inner_macros. A vec invocation there would resolve to $crate::vec.</span>
<span class="comment">// Instead invoke vec here outside of local_inner_macros.</span>
<span class="attribute">#[<span class="ident">macro_export</span>]</span>
<span class="attribute">#[<span class="ident">doc</span>(<span class="ident">hidden</span>)]</span>
<span class="macro">macro_rules!</span> <span class="ident">json_internal_vec</span> {
    ($(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">content</span>:<span class="ident">tt</span>)<span class="kw-2">*</span>) <span class="op">=</span><span class="op">&gt;</span> {
        <span class="macro">vec!</span>[$(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">content</span>)<span class="kw-2">*</span>]
    };
}

<span class="attribute">#[<span class="ident">macro_export</span>]</span>
<span class="attribute">#[<span class="ident">doc</span>(<span class="ident">hidden</span>)]</span>
<span class="macro">macro_rules!</span> <span class="ident">json_unexpected</span> {
    () <span class="op">=</span><span class="op">&gt;</span> {};
}

<span class="attribute">#[<span class="ident">macro_export</span>]</span>
<span class="attribute">#[<span class="ident">doc</span>(<span class="ident">hidden</span>)]</span>
<span class="macro">macro_rules!</span> <span class="ident">json_expect_expr_comma</span> {
    (<span class="macro-nonterminal">$</span><span class="macro-nonterminal">e</span>:<span class="ident">expr</span> , $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">tt</span>:<span class="ident">tt</span>)<span class="kw-2">*</span>) <span class="op">=</span><span class="op">&gt;</span> {};
}
</code></pre></div>
</section><section id="search" class="content hidden"></section><div id="rustdoc-vars" data-root-path="../../" data-current-crate="serde_json" data-search-index-js="../../search-index.js" data-search-js="../../search.js"></div>
    <script src="../../main.js"></script><script src="../../source-script.js"></script><script src="../../source-files.js"></script>
</body></html>